import os
import torch
import torchvision
import numpy as np
import time
import matplotlib.pyplot as plt
import matplotlib.patches as patches
import sys
sys.path.insert(0, '../')
sys.path.insert(0, './')
from visualize_proposals import draw_proposals, draw_predictions
from visualize_cam import draw_cam

TEST_DATA_DIR = '[data directory]'


def load_all_test_gt_labels():
    gt_filepath = os.path.join(TEST_DATA_DIR, "test_gt_labels.txt")
    gt = []
    with open(gt_filepath, mode='r', encoding='utf-8') as f:
        lines = f.readlines()
        for line in lines:
            if line == '\n':
                gt.append(None)
            else:
                gt.append(torch.IntTensor([int(e) - 1 for e in line.rstrip().split(' ')]))
    return gt


def load_all_test_gt_boxes():
    gt_filepath = os.path.join(TEST_DATA_DIR, "test_gt_boxes.txt")
    gt = []
    with open(gt_filepath, mode='r', encoding='utf-8') as f:
        lines = f.readlines()
        single_gt = []
        first_flg, gt_num = True, 0
        for line in lines:
            if line == "GTBOXES\n":
                gt_num += 1
                if not first_flg:
                    if not single_gt:
                        gt.append(None)
                    else:
                        gt.append(torch.FloatTensor(single_gt))
                    single_gt = []
                else:
                    first_flg = False
            else:
                _tmp = [float(e) for e in line.rstrip().split(' ')]
                _tmp[0], _tmp[2] = 640 * _tmp[0], 640 * _tmp[2]
                _tmp[1], _tmp[3] = 480 * _tmp[1], 480 * _tmp[3]
                single_gt.append(_tmp)

        if single_gt:
            gt.append(torch.FloatTensor(single_gt))

        else:
            gt.append(None)
    return gt

# gray_transformer = torchvision.transforms.Grayscale()


def gray_transformer(tensor):
    if len(tensor.shape) == 3:
        return (0.21 * tensor[0, :, :] + 0.72 * tensor[1, :, :] + 0.07 * tensor[2, :, :]).unsqueeze(0)
    elif len(tensor.shape) == 4:
        raise Exception('Not Implemented')


if __name__ == '__main__':
    test_gt_boxes = load_all_test_gt_boxes()
    test_gt_labels = load_all_test_gt_labels()
    proposals = np.load(f'./test_proposal_boxes_100.npy')
    # targets = torch.load('../../data/test_targets_100.pt')
    imgs = torch.load(f'{TEST_DATA_DIR}/test_imgs_100.pt')
    pred_dir_name = 'complete24999'

    cnt = 0
    num_pred = 4
    while cnt <= 99:
        cnt += 1
        if test_gt_labels[cnt - 1] is None:
            continue
        if not os.path.exists(f'pred/{pred_dir_name}/pred_scores_{cnt}0.npy'):
            continue
        scores = np.load(f'pred/{pred_dir_name}/pred_scores_{cnt}0.npy')
        scores_partial_sorted = np.argpartition(-scores, num_pred)
        top_indices = scores_partial_sorted[:num_pred]
        # draw_proposals(imgs[i][:3, :, :],
        #                (test_gt_boxes[i], np.load(f"pred/{pred_dir_name}/pred_boxes_{cnt}0.npy")[top_indices, :]),
        #                colors=('g', 'r'))
        # time.sleep(3)
        # draw_proposals(imgs[i][3:, :, :],
        #                (test_gt_boxes[i], np.load(f"pred/{pred_dir_name}/pred_boxes_{cnt}0.npy")[top_indices, :]),
        #                colors=('g', 'r'))

        draw_proposals(imgs[cnt - 1][:3, :, :],
                       [],
                       colors=[])
        time.sleep(1)
        draw_proposals(imgs[cnt - 1][3:, :, :],
                       [],
                       colors=[])

        # draw_proposals(imgs[i][3:, :, :], (test_gt_boxes[i],), colors=('g',))
        time.sleep(1)
        draw_cam(np.load(f"pred/{pred_dir_name}/pred_conf_map_{cnt}0.npy"))
        # draw_predictions(imgs[cnt - 1][3:, :, :],
        #                  (test_gt_boxes[cnt - 1], np.load(f"pred/{pred_dir_name}/pred_boxes_{cnt}0.npy")[top_indices, :]),
        #                  np.load(f"pred/{pred_dir_name}/pred_labels_{cnt}0.npy")[top_indices],
        #                  np.load(f"pred/{pred_dir_name}/pred_scores_{cnt}0.npy")[top_indices])

        x = input("If continue: [1/0]")
        if x == '0':
            num_pred = int(input('number of prediction'))
            cnt -= 1

        # diff = torch.abs(gray_transformer(imgs[i][3:, :, :]) - gray_transformer(imgs[i][:3, :, :]))
        # diff[diff > 50] = 255
        # diff[diff <= 50] = 0
        # print(diff)
        # draw_proposals(diff, (), colors=())
        # time.sleep(3)