import numpy as np
import matplotlib.pyplot as plt
import sys
sys.path.insert(0, "../datasets")
import time
import cv2

idx2name = {0: 'cyclist', 1: 'car', 2: 'truck', 3: 'person'}


def draw_cam(confidence_map: np.ndarray):
    size_upsample = (640, 480)

    for idx in range(confidence_map.shape[0]):
        fig, ax = plt.subplots()  # Create figure and axes
        cam = confidence_map[idx, :, :]
        cam = mirrow(cam)
        cam = cam - np.min(cam)
        cam_img = cam / np.max(cam)
        cam_img = np.uint8(255 * cam_img)
        resized_cam_img = cv2.resize(cam_img, size_upsample)
        ax.imshow(resized_cam_img)  # Display the image
        ax.text(30, 30, f"{idx2name[idx]}", style='italic', color="white", size="large")
        plt.show()
        plt.close()
        time.sleep(1.5)


def mirrow(array: np.ndarray):
    mi = np.zeros_like(array)
    num_col = mi.shape[1]
    for col in range(num_col):
        mi[:, col] = array[:, num_col - col - 1]
    return mi